#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_HealthGame.h"
std::auto_ptr<M_HealthGame> M_HealthGame::msSingleton(nullptr);

int M_HealthGame::GetCount()
{
	return (int)mMapData.size();
}

const M_HealthGameData* M_HealthGame::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_HealthGameData>& M_HealthGame::GetMapData()
{
	return mMapData;
}

void M_HealthGame::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_HealthGame.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_HealthGameData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->Attribute("Type");
		data.mDescribe = element->Attribute("Describe");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_HealthGame Loaded. Load Data:%u", mMapData.size());
}

void M_HealthGame::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_HealthGame");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_HealthGame");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_HealthGameData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Type", data.mType);
		LuaCfgHelper::readString(L, "Describe", data.mDescribe);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_HealthGame Loaded. Load Data:%u", mMapData.size());
}

void M_HealthGame::Reload()
{
	mMapData.clear();
	Load();
}

M_HealthGame* M_HealthGame::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_HealthGame());
	}
	return msSingleton.get();
}

void M_HealthGame::Release()
{
	msSingleton.reset(nullptr);
}
